﻿using System;
using System.Threading.Tasks;
using DeukBot4.Utilities;
using Discord.WebSocket;

namespace DeukBot4.MessageHandlers
{
    public static class MainHandler
    {
        public static async Task HandleMessage(SocketMessage message)
        {
            if (message.Author.Id == Program.Client.CurrentUser.Id)
            {
                return;
            }
            try
            {
#pragma warning disable 4014
                CommandHandler.CommandHandler.HandleMessage(message);
                HandlePrivateMessage(message);
                ImageBackupHandler.Backup(message);
                DeltaHandler(message);
#pragma warning restore 4014
            }
            catch (Exception e)
            {
                await Logger.LogError(e.ToString());
            }
        }

        private static async Task HandlePrivateMessage(SocketMessage message)
        {
            if (message.Channel is ISocketPrivateChannel)
            {
                await Logger.Log(($"Private Message: {message.Author.Username}- {message.Content}"));
            }
        }

        private static async Task DeltaHandler(SocketMessage message)
        {
            var lower = message.Content.ToLowerInvariant().RemoveSpecialCharacters().Split(' ');
            foreach (var s in lower)
            {
                var diff = Lehvenstein.LevenshteinDistance(s, "delta");
                if (diff <= 1)
                {
                    await message.Channel.SendMessageAsync("uhh excuse me it's called Origin and it's an art");
                    break;
                }

            }

        }
    }
}